package com.shinsoft.dameng.test.service.impl;

import com.shinsoft.dameng.test.model.App;
import com.shinsoft.dameng.test.mapper.AppMapper;
    import com.shinsoft.dameng.test.service.AppService;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import org.springframework.stereotype.Service;


import org.springframework.beans.factory.annotation.Autowired;
import java.util.Date;
import java.util.List;
import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONObject;
import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.TypeReference;
import com.shinsoft.tools.JSONTools;
import com.shinsoft.tools.model.common.ResultJSON;
import org.apache.commons.lang3.StringUtils;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import org.apache.commons.lang3.ObjectUtils;
import org.apache.commons.lang3.StringUtils;

/**
* <p>
    *  服务实现类
    * </p>
*
* @author system
* @since 2025-04-24
*/
@Service
    public class AppServiceImpl extends ServiceImpl<AppMapper, App> implements AppService {


    ResultJSON resultJSON;

    @Autowired
    AppMapper appMapper;

    @Override
    public ResultJSON query(int page,int rows,String params){
    JSONObject jsonObject=JSON.parseObject(params);
                JSONArray cDatetimeRange = jsonObject.getJSONArray("cDatetime");
                Date cDatetimeBegin = cDatetimeRange.getDate(0);
                Date cDatetimeEnd = cDatetimeRange.getDate(1);
            String cVarchar = jsonObject.getString("cVarchar");
    Page<App> appPage=new Page<>(page,rows);
    QueryWrapper<App>queryWrapper=new QueryWrapper<>();
    queryWrapper.eq("cancel_flag","0");
                queryWrapper.between(ObjectUtils.isNotEmpty(cDatetimeBegin),"C_DATETIME",cDatetimeBegin, cDatetimeEnd);
                queryWrapper.like(StringUtils.isNotEmpty(cVarchar),"C_VARCHAR",cVarchar);
    queryWrapper.orderByDesc("add_time");
    Page<App>list= appMapper.selectPage(appPage,queryWrapper);
    resultJSON=JSONTools.toResultJSON(list);
    return resultJSON;
    }

    @Override
    public ResultJSON queryByPK(String id) {
    App app =  appMapper.selectByPK(id);
    resultJSON = JSONTools.toResultJSON(app);
    return resultJSON;
    }


    @Override
    public ResultJSON save(String userId,String json){
    Date date = new Date();
    App app =JSON.parseObject(json,new TypeReference<App>(){
    });
    if(StringUtils.isEmpty(app.getId())){
    app.setCancelFlag("0");
    app.setAddId(userId);
    app.setAddTime(date);
    appMapper.insert(app);
    }else{
    app.setModifyId(userId);
    app.setModifyTime(date);
    appMapper.updateById(app);
    }

    resultJSON=JSONTools.toResultJSON(app);
    return resultJSON;
    }

    @Override
    public ResultJSON remove(String userId,String id){
    Date date=new Date();
    App app = appMapper.selectById(id);
    app.setCancelFlag("1");
    app.setCancelId(userId);
    app.setCancelTime(date);
    appMapper.updateById(app);
    resultJSON=JSONTools.toResultJSON("");
    return resultJSON;
    }

    @Override
    public ResultJSON removeBatch(String userId, String ids) {
    Date date = new Date();
    List<String> list = JSON.parseObject(ids,new TypeReference<List<String>>() {
    });
    App app;
    for(String id :list){
    app = appMapper.selectById(id);
    app.setCancelFlag("1");
    app.setCancelId(userId);
    app.setCancelTime(date);
    appMapper.updateById(app);
    }
    resultJSON = JSONTools.toResultJSON("");
    return resultJSON;
    }

    }
