package com.shinsoft.dameng.test.service.impl;

import com.shinsoft.dameng.test.model.ContractorEvaluate;
import com.shinsoft.dameng.test.mapper.ContractorEvaluateMapper;
import com.shinsoft.dameng.test.service.ContractorEvaluateService;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import org.springframework.stereotype.Service;


import org.springframework.beans.factory.annotation.Autowired;

import java.util.Date;
import java.util.List;

import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONObject;
import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.TypeReference;
import com.shinsoft.tools.JSONTools;
import com.shinsoft.tools.model.common.ResultJSON;
import org.apache.commons.lang3.StringUtils;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import org.apache.commons.lang3.ObjectUtils;
import org.apache.commons.lang3.StringUtils;

/**
 * <p>
 * 相关方名录表 服务实现类
 * </p>
 *
 * @author system
 * @since 2025-04-24
 */
@Service
public class ContractorEvaluateServiceImpl extends ServiceImpl<ContractorEvaluateMapper, ContractorEvaluate> implements ContractorEvaluateService {


    ResultJSON resultJSON;

    @Autowired
    ContractorEvaluateMapper contractorEvaluateMapper;

    @Override
    public ResultJSON query(int page, int rows, String params) {
        JSONObject jsonObject = JSON.parseObject(params);
        String addCode = jsonObject.getString("addCode");
        String addName = jsonObject.getString("addName");
        Page<ContractorEvaluate> contractorEvaluatePage = new Page<>(page, rows);
        QueryWrapper<ContractorEvaluate> queryWrapper = new QueryWrapper<>();
        queryWrapper.eq("cancel_flag", "0");
        queryWrapper.eq(StringUtils.isNotEmpty(addCode), "ADD_CODE", addCode);
        queryWrapper.like(StringUtils.isNotEmpty(addName), "ADD_NAME", addName);
        queryWrapper.orderByDesc("add_time");
        Page<ContractorEvaluate> list = contractorEvaluateMapper.selectPage(contractorEvaluatePage, queryWrapper);
        resultJSON = JSONTools.toResultJSON(list);
        return resultJSON;
    }

    @Override
    public ResultJSON queryByPK(String id) {
        ContractorEvaluate contractorEvaluate = contractorEvaluateMapper.selectByPK(id);
        resultJSON = JSONTools.toResultJSON(contractorEvaluate);
        return resultJSON;
    }


    @Override
    public ResultJSON save(String userId, String json) {
        Date date = new Date();
        ContractorEvaluate contractorEvaluate = JSON.parseObject(json, new TypeReference<ContractorEvaluate>() {
        });
        if (StringUtils.isEmpty(contractorEvaluate.getId())) {
            contractorEvaluate.setCancelFlag("0");
            contractorEvaluate.setAddId(userId);
            contractorEvaluate.setAddTime(date);
            contractorEvaluateMapper.insert(contractorEvaluate);
        } else {
            contractorEvaluate.setModifyId(userId);
            contractorEvaluate.setModifyTime(date);
            contractorEvaluateMapper.updateById(contractorEvaluate);
        }

        resultJSON = JSONTools.toResultJSON(contractorEvaluate);
        return resultJSON;
    }

    @Override
    public ResultJSON remove(String userId, String id) {
        Date date = new Date();
        ContractorEvaluate contractorEvaluate = contractorEvaluateMapper.selectById(id);
        contractorEvaluate.setCancelFlag("1");
        contractorEvaluate.setCancelId(userId);
        contractorEvaluate.setCancelTime(date);
        contractorEvaluateMapper.updateById(contractorEvaluate);
        resultJSON = JSONTools.toResultJSON("");
        return resultJSON;
    }

    @Override
    public ResultJSON removeBatch(String userId, String ids) {
        Date date = new Date();
        List<String> list = JSON.parseObject(ids, new TypeReference<List<String>>() {
        });
        ContractorEvaluate contractorEvaluate;
        for (String id : list) {
            contractorEvaluate = contractorEvaluateMapper.selectById(id);
            contractorEvaluate.setCancelFlag("1");
            contractorEvaluate.setCancelId(userId);
            contractorEvaluate.setCancelTime(date);
            contractorEvaluateMapper.updateById(contractorEvaluate);
        }
        resultJSON = JSONTools.toResultJSON("");
        return resultJSON;
    }

}
