package com.shinsoft.oracle.EXP.service.impl;

import com.shinsoft.oracle.EXP.model.TestShangyingxu;
import com.shinsoft.oracle.EXP.mapper.TestShangyingxuMapper;
    import com.shinsoft.oracle.EXP.service.TestShangyingxuService;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import org.springframework.stereotype.Service;


import org.springframework.beans.factory.annotation.Autowired;
import java.util.Date;
import java.util.List;
import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONObject;
import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.TypeReference;
import com.shinsoft.tools.JSONTools;
import com.shinsoft.tools.model.common.ResultJSON;
import org.apache.commons.lang3.StringUtils;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import org.apache.commons.lang3.ObjectUtils;
import org.apache.commons.lang3.StringUtils;

/**
* <p>
    *  服务实现类
    * </p>
*
* @author system
* @since 2025-05-09
*/
@Service
    public class TestShangyingxuServiceImpl extends ServiceImpl<TestShangyingxuMapper, TestShangyingxu> implements TestShangyingxuService {


    ResultJSON resultJSON;

    @Autowired
    TestShangyingxuMapper testShangyingxuMapper;

    @Override
    public ResultJSON query(int page,int rows,String params){
    JSONObject jsonObject=JSON.parseObject(params);
            String name = jsonObject.getString("name");
            String age = jsonObject.getString("age");
    Page<TestShangyingxu> testShangyingxuPage=new Page<>(page,rows);
    QueryWrapper<TestShangyingxu>queryWrapper=new QueryWrapper<>();
    queryWrapper.eq("cancel_flag","0");
                queryWrapper.like(StringUtils.isNotEmpty(name),"NAME",name);
                queryWrapper.like(StringUtils.isNotEmpty(age),"AGE",age);
    queryWrapper.orderByDesc("add_time");
    Page<TestShangyingxu>list= testShangyingxuMapper.selectPage(testShangyingxuPage,queryWrapper);
    resultJSON=JSONTools.toResultJSON(list);
    return resultJSON;
    }

    @Override
    public ResultJSON queryByPK(String id) {
        TestShangyingxu testShangyingxu =  testShangyingxuMapper.selectByPK(id);
        resultJSON = JSONTools.toResultJSON(testShangyingxu);
        return resultJSON;
    }


    @Override
    public ResultJSON save(String userId,String json){
    Date date = new Date();
    TestShangyingxu testShangyingxu =JSON.parseObject(json,new TypeReference<TestShangyingxu>(){
    });
    if(StringUtils.isEmpty(testShangyingxu.getId())){
    testShangyingxu.setCancelFlag("0");
    testShangyingxu.setAddId(userId);
    testShangyingxu.setAddTime(date);
    testShangyingxuMapper.insert(testShangyingxu);
    }else{
    testShangyingxu.setModifyId(userId);
    testShangyingxu.setModifyTime(date);
    testShangyingxuMapper.updateById(testShangyingxu);
    }

    resultJSON=JSONTools.toResultJSON(testShangyingxu);
    return resultJSON;
    }

    @Override
    public ResultJSON remove(String userId,String id){
    Date date=new Date();
    TestShangyingxu testShangyingxu = testShangyingxuMapper.selectById(id);
    testShangyingxu.setCancelFlag("1");
    testShangyingxu.setCancelId(userId);
    testShangyingxu.setCancelTime(date);
    testShangyingxuMapper.updateById(testShangyingxu);
    resultJSON=JSONTools.toResultJSON("");
    return resultJSON;
    }

        @Override
        public ResultJSON removeBatch(String userId, String ids) {
            Date date = new Date();
            List<String> list = JSON.parseObject(ids,new TypeReference<List<String>>() {
            });
            TestShangyingxu testShangyingxu;
            for(String id :list){
                testShangyingxu = testShangyingxuMapper.selectById(id);
                testShangyingxu.setCancelFlag("1");
                testShangyingxu.setCancelId(userId);
                testShangyingxu.setCancelTime(date);
                testShangyingxuMapper.updateById(testShangyingxu);
            }
            resultJSON = JSONTools.toResultJSON("");
            return resultJSON;
        }

    }
