package com.shinsoft.oracle.LY.service.impl;

import com.shinsoft.oracle.LY.model.Liying;
import com.shinsoft.oracle.LY.mapper.LiyingMapper;
    import com.shinsoft.oracle.LY.service.LiyingService;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import org.springframework.stereotype.Service;


import org.springframework.beans.factory.annotation.Autowired;
import java.util.Date;
import java.util.List;
import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONObject;
import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.TypeReference;
import com.shinsoft.tools.JSONTools;
import com.shinsoft.tools.model.common.ResultJSON;
import org.apache.commons.lang3.StringUtils;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import org.apache.commons.lang3.ObjectUtils;
import org.apache.commons.lang3.StringUtils;

/**
* <p>
    *  服务实现类
    * </p>
*
* @author system
* @since 2025-05-08
*/
@Service
    public class LiyingServiceImpl extends ServiceImpl<LiyingMapper, Liying> implements LiyingService {


    ResultJSON resultJSON;

    @Autowired
    LiyingMapper liyingMapper;

    @Override
    public ResultJSON query(int page,int rows,String params){
    JSONObject jsonObject=JSON.parseObject(params);
            String score = jsonObject.getString("score");
            String name1 = jsonObject.getString("name1");
    Page<Liying> liyingPage=new Page<>(page,rows);
    QueryWrapper<Liying>queryWrapper=new QueryWrapper<>();
    queryWrapper.eq("cancel_flag","0");
                queryWrapper.like(StringUtils.isNotEmpty(score),"SCORE",score);
                queryWrapper.like(StringUtils.isNotEmpty(name1),"NAME_1",name1);
    queryWrapper.orderByDesc("add_time");
    Page<Liying>list= liyingMapper.selectPage(liyingPage,queryWrapper);
    resultJSON=JSONTools.toResultJSON(list);
    return resultJSON;
    }

    @Override
    public ResultJSON queryByPK(String id) {
        Liying liying =  liyingMapper.selectByPK(id);
        resultJSON = JSONTools.toResultJSON(liying);
        return resultJSON;
    }


    @Override
    public ResultJSON save(String userId,String json){
    Date date = new Date();
    Liying liying =JSON.parseObject(json,new TypeReference<Liying>(){
    });
    if(StringUtils.isEmpty(liying.getId())){
    liying.setCancelFlag("0");
    liying.setAddId(userId);
    liying.setAddTime(date);
    liyingMapper.insert(liying);
    }else{
    liying.setModifyId(userId);
    liying.setModifyTime(date);
    liyingMapper.updateById(liying);
    }

    resultJSON=JSONTools.toResultJSON(liying);
    return resultJSON;
    }

    @Override
    public ResultJSON remove(String userId,String id){
    Date date=new Date();
    Liying liying = liyingMapper.selectById(id);
    liying.setCancelFlag("1");
    liying.setCancelId(userId);
    liying.setCancelTime(date);
    liyingMapper.updateById(liying);
    resultJSON=JSONTools.toResultJSON("");
    return resultJSON;
    }

        @Override
        public ResultJSON removeBatch(String userId, String ids) {
            Date date = new Date();
            List<String> list = JSON.parseObject(ids,new TypeReference<List<String>>() {
            });
            Liying liying;
            for(String id :list){
                liying = liyingMapper.selectById(id);
                liying.setCancelFlag("1");
                liying.setCancelId(userId);
                liying.setCancelTime(date);
                liyingMapper.updateById(liying);
            }
            resultJSON = JSONTools.toResultJSON("");
            return resultJSON;
        }

    }
