package com.shinsoft.oracle.chenhuijie.service.impl;

import com.shinsoft.oracle.chenhuijie.model.Chenhuijie;
import com.shinsoft.oracle.chenhuijie.mapper.ChenhuijieMapper;
    import com.shinsoft.oracle.chenhuijie.service.ChenhuijieService;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import org.springframework.stereotype.Service;


import org.springframework.beans.factory.annotation.Autowired;
import java.util.Date;
import java.util.List;
import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONObject;
import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.TypeReference;
import com.shinsoft.tools.JSONTools;
import com.shinsoft.tools.model.common.ResultJSON;
import org.apache.commons.lang3.StringUtils;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import org.apache.commons.lang3.ObjectUtils;
import org.apache.commons.lang3.StringUtils;

/**
* <p>
    *  服务实现类
    * </p>
*
* @author system
* @since 2025-05-08
*/
@Service
    public class ChenhuijieServiceImpl extends ServiceImpl<ChenhuijieMapper, Chenhuijie> implements ChenhuijieService {


    ResultJSON resultJSON;

    @Autowired
    ChenhuijieMapper chenhuijieMapper;

    @Override
    public ResultJSON query(int page,int rows,String params){
    JSONObject jsonObject=JSON.parseObject(params);
            String name = jsonObject.getString("name");
            String test = jsonObject.getString("test");
    Page<Chenhuijie> chenhuijiePage=new Page<>(page,rows);
    QueryWrapper<Chenhuijie>queryWrapper=new QueryWrapper<>();
    queryWrapper.eq("cancel_flag","0");
                     queryWrapper.eq(StringUtils.isNotEmpty(name),"NAME",name);
                     queryWrapper.eq(StringUtils.isNotEmpty(test),"TEST",test);
    queryWrapper.orderByDesc("add_time");
    Page<Chenhuijie>list= chenhuijieMapper.selectPage(chenhuijiePage,queryWrapper);
    resultJSON=JSONTools.toResultJSON(list);
    return resultJSON;
    }

    @Override
    public ResultJSON queryByPK(String id) {
        Chenhuijie chenhuijie =  chenhuijieMapper.selectByPK(id);
        resultJSON = JSONTools.toResultJSON(chenhuijie);
        return resultJSON;
    }


    @Override
    public ResultJSON save(String userId,String json){
    Date date = new Date();
    Chenhuijie chenhuijie =JSON.parseObject(json,new TypeReference<Chenhuijie>(){
    });
    if(StringUtils.isEmpty(chenhuijie.getId())){
    chenhuijie.setCancelFlag("0");
    chenhuijie.setAddId(userId);
    chenhuijie.setAddTime(date);
    chenhuijieMapper.insert(chenhuijie);
    }else{
    chenhuijie.setModifyId(userId);
    chenhuijie.setModifyTime(date);
    chenhuijieMapper.updateById(chenhuijie);
    }

    resultJSON=JSONTools.toResultJSON(chenhuijie);
    return resultJSON;
    }

    @Override
    public ResultJSON remove(String userId,String id){
    Date date=new Date();
    Chenhuijie chenhuijie = chenhuijieMapper.selectById(id);
    chenhuijie.setCancelFlag("1");
    chenhuijie.setCancelId(userId);
    chenhuijie.setCancelTime(date);
    chenhuijieMapper.updateById(chenhuijie);
    resultJSON=JSONTools.toResultJSON("");
    return resultJSON;
    }

        @Override
        public ResultJSON removeBatch(String userId, String ids) {
            Date date = new Date();
            List<String> list = JSON.parseObject(ids,new TypeReference<List<String>>() {
            });
            Chenhuijie chenhuijie;
            for(String id :list){
                chenhuijie = chenhuijieMapper.selectById(id);
                chenhuijie.setCancelFlag("1");
                chenhuijie.setCancelId(userId);
                chenhuijie.setCancelTime(date);
                chenhuijieMapper.updateById(chenhuijie);
            }
            resultJSON = JSONTools.toResultJSON("");
            return resultJSON;
        }

    }
