package com.shinsoft.oracle.jinlei.service.impl;

import com.shinsoft.oracle.jinlei.model.Jinlei;
import com.shinsoft.oracle.jinlei.mapper.JinleiMapper;
    import com.shinsoft.oracle.jinlei.service.JinleiService;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import org.springframework.stereotype.Service;


import org.springframework.beans.factory.annotation.Autowired;
import java.util.Date;
import java.util.List;
import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONObject;
import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.TypeReference;
import com.shinsoft.tools.JSONTools;
import com.shinsoft.tools.model.common.ResultJSON;
import org.apache.commons.lang3.StringUtils;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import org.apache.commons.lang3.ObjectUtils;
import org.apache.commons.lang3.StringUtils;

/**
* <p>
    *  服务实现类
    * </p>
*
* @author system
* @since 2025-05-09
*/
@Service
    public class JinleiServiceImp extends ServiceImpl<JinleiMapper, Jinlei> implements JinleiService {


    ResultJSON resultJSON;

    @Autowired
    JinleiMapper jinleiMapper;

    @Override
    public ResultJSON query(int page,int rows,String params){
    JSONObject jsonObject=JSON.parseObject(params);
            String code = jsonObject.getString("code");
    Page<Jinlei> jinleiPage=new Page<>(page,rows);
    QueryWrapper<Jinlei>queryWrapper=new QueryWrapper<>();
    queryWrapper.eq("cancel_flag","0");
                     queryWrapper.eq(StringUtils.isNotEmpty(code),"CODE",code);
    queryWrapper.orderByDesc("add_time");
    Page<Jinlei>list= jinleiMapper.selectPage(jinleiPage,queryWrapper);
    resultJSON=JSONTools.toResultJSON(list);
    return resultJSON;
    }

    @Override
    public ResultJSON queryByPK(String id) {
        Jinlei jinlei =  jinleiMapper.selectByPK(id);
        resultJSON = JSONTools.toResultJSON(jinlei);
        return resultJSON;
    }


    @Override
    public ResultJSON save(String userId,String json){
    Date date = new Date();
    Jinlei jinlei =JSON.parseObject(json,new TypeReference<Jinlei>(){
    });
    if(StringUtils.isEmpty(jinlei.getId())){
    jinlei.setCancelFlag("0");
    jinlei.setAddId(userId);
    jinlei.setAddTime(date);
    jinleiMapper.insert(jinlei);
    }else{
    jinlei.setModifyId(userId);
    jinlei.setModifyTime(date);
    jinleiMapper.updateById(jinlei);
    }

    resultJSON=JSONTools.toResultJSON(jinlei);
    return resultJSON;
    }

    @Override
    public ResultJSON remove(String userId,String id){
    Date date=new Date();
    Jinlei jinlei = jinleiMapper.selectById(id);
    jinlei.setCancelFlag("1");
    jinlei.setCancelId(userId);
    jinlei.setCancelTime(date);
    jinleiMapper.updateById(jinlei);
    resultJSON=JSONTools.toResultJSON("");
    return resultJSON;
    }

        @Override
        public ResultJSON removeBatch(String userId, String ids) {
            Date date = new Date();
            List<String> list = JSON.parseObject(ids,new TypeReference<List<String>>() {
            });
            Jinlei jinlei;
            for(String id :list){
                jinlei = jinleiMapper.selectById(id);
                jinlei.setCancelFlag("1");
                jinlei.setCancelId(userId);
                jinlei.setCancelTime(date);
                jinleiMapper.updateById(jinlei);
            }
            resultJSON = JSONTools.toResultJSON("");
            return resultJSON;
        }

    }
