package com.shinsoft.oracle.my.service.impl;

import com.shinsoft.oracle.my.model.Test;
import com.shinsoft.oracle.my.mapper.TestMapper;
    import com.shinsoft.oracle.my.service.TestService;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import org.springframework.stereotype.Service;


import org.springframework.beans.factory.annotation.Autowired;
import java.util.Date;
import java.util.List;
import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONObject;
import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.TypeReference;
import com.shinsoft.tools.JSONTools;
import com.shinsoft.tools.model.common.ResultJSON;
import org.apache.commons.lang3.StringUtils;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import org.apache.commons.lang3.ObjectUtils;
import org.apache.commons.lang3.StringUtils;

/**
* <p>
    *  服务实现类
    * </p>
*
* @author system
* @since 2025-04-24
*/
@Service
    public class TestServiceImpl extends ServiceImpl<TestMapper, Test> implements TestService {


    ResultJSON resultJSON;

    @Autowired
    TestMapper testMapper;

    @Override
    public ResultJSON query(int page,int rows,String params){
    JSONObject jsonObject=JSON.parseObject(params);
            String testName = jsonObject.getString("testName");
                JSONArray testTimeRange = jsonObject.getJSONArray("testTime");
                Date testTimeBegin = testTimeRange.getDate(0);
                Date testTimeEnd = testTimeRange.getDate(1);
    Page<Test> testPage=new Page<>(page,rows);
    QueryWrapper<Test>queryWrapper=new QueryWrapper<>();
    queryWrapper.eq("cancel_flag","0");
                queryWrapper.like(StringUtils.isNotEmpty(testName),"TEST_NAME",testName);
                 queryWrapper.between(ObjectUtils.isNotEmpty(testTimeBegin),"TEST_TIME",testTimeBegin, testTimeEnd);
    queryWrapper.orderByDesc("add_time");
    Page<Test>list= testMapper.selectPage(testPage,queryWrapper);
    resultJSON=JSONTools.toResultJSON(list);
    return resultJSON;
    }

    @Override
    public ResultJSON queryByPK(String id) {
        Test test =  testMapper.selectByPK(id);
        resultJSON = JSONTools.toResultJSON(test);
        return resultJSON;
    }


    @Override
    public ResultJSON save(String userId,String json){
    Date date = new Date();
    Test test =JSON.parseObject(json,new TypeReference<Test>(){
    });
    if(StringUtils.isEmpty(test.getId())){
    test.setCancelFlag("0");
    test.setAddId(userId);
    test.setAddTime(date);
    testMapper.insert(test);
    }else{
    test.setModifyId(userId);
    test.setModifyTime(date);
    testMapper.updateById(test);
    }

    resultJSON=JSONTools.toResultJSON(test);
    return resultJSON;
    }

    @Override
    public ResultJSON remove(String userId,String id){
    Date date=new Date();
    Test test = testMapper.selectById(id);
    test.setCancelFlag("1");
    test.setCancelId(userId);
    test.setCancelTime(date);
    testMapper.updateById(test);
    resultJSON=JSONTools.toResultJSON("");
    return resultJSON;
    }

        @Override
        public ResultJSON removeBatch(String userId, String ids) {
            Date date = new Date();
            List<String> list = JSON.parseObject(ids,new TypeReference<List<String>>() {
            });
            Test test;
            for(String id :list){
                test = testMapper.selectById(id);
                test.setCancelFlag("1");
                test.setCancelId(userId);
                test.setCancelTime(date);
                testMapper.updateById(test);
            }
            resultJSON = JSONTools.toResultJSON("");
            return resultJSON;
        }

    }
