package com.shinsoft.oracle.pur.model;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import com.shinsoft.generator.model.BaseModel;
import java.io.Serializable;
import java.util.Date;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Getter;
import lombok.Setter;
import lombok.experimental.Accessors;
import com.alibaba.fastjson.annotation.JSONField;

/**
 * <p>
 * 采购订单头
 * </p>
 *
 * @author system
 * @since 2025-04-24
 */
@Getter
@Setter
@Accessors(chain = true)
@TableName("PUR_ORD_HEAD")
@ApiModel(value = "OrdHead对象", description = "采购订单头")
public class OrdHead extends BaseModel {

    private static final long serialVersionUID = 1L;

    @ApiModelProperty("公司代码")
    private String compCd;

    @ApiModelProperty("订单号")
    private String purOrdNo;

    @ApiModelProperty("合同ID")
    private String contrId;

    @ApiModelProperty("合同编码")
    private String contrNo;

    @ApiModelProperty("合同名称")
    private String contrNm;

    @ApiModelProperty("供应商编码")
    private String tradePartnerCode;

    @ApiModelProperty("供应商名称")
    private String tradePartnerName;

    @ApiModelProperty("采购部门编码")
    private String deptCd;

    @ApiModelProperty("采购部门")
    private String deptNm;

    @ApiModelProperty("合同日期")
    private Date contrDt;

    @ApiModelProperty("币种")
    private String cur;

    @ApiModelProperty("付款方式")
    private String payMth;

    @ApiModelProperty("交货方式")
    private String delvMth;

    @ApiModelProperty("交货地点")
    private String delvPlace;

    @ApiModelProperty("交货日期")
    private Date delvDt;

    @ApiModelProperty("运输方式")
    private String trsMth;

    @ApiModelProperty("订单类型")
    private String ordTy;

    @ApiModelProperty("采购类型")
    private String purTy;

    @ApiModelProperty("备注")
    private String remark;

    @ApiModelProperty("确认人")
    private String checkName;

    @ApiModelProperty("确认标记")
    private String checkFlag;

    @ApiModelProperty("确认时间")
    private Date checkDtm;

    @ApiModelProperty("订单状态")
    private String purOrdSts;

    @ApiModelProperty("数量")
    private Short qty;

    @ApiModelProperty("计量单位")
    private String uom;

    @ApiModelProperty("进口国家")
    private String countryCd;

    @ApiModelProperty("到货港口")
    private String port;

    @ApiModelProperty("结算方式")
    private String invMth;

    @ApiModelProperty("合同汇率")
    private Short contrExRate;

    @ApiModelProperty("锁汇汇率")
    private Short lockExRate;

    @ApiModelProperty("汇率日期")
    private Date exRateDt;

    @ApiModelProperty("定价方式（锁价/后结算）")
    private String fixPriceTy;

    @ApiModelProperty("供应商ID")
    private String tradePartnerId;

    @ApiModelProperty("对方合同编号")
    private String khContrNo;

    @ApiModelProperty("发货地址")
    private String fromPlace;
}
