package com.shinsoft.oracle.pur.service.impl;

import com.shinsoft.oracle.pur.model.OrdHead;
import com.shinsoft.oracle.pur.mapper.OrdHeadMapper;
    import com.shinsoft.oracle.pur.service.OrdHeadService;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import org.springframework.stereotype.Service;


import org.springframework.beans.factory.annotation.Autowired;
import java.util.Date;
import java.util.List;
import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONObject;
import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.TypeReference;
import com.shinsoft.tools.JSONTools;
import com.shinsoft.tools.model.common.ResultJSON;
import org.apache.commons.lang3.StringUtils;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import org.apache.commons.lang3.ObjectUtils;
import org.apache.commons.lang3.StringUtils;

/**
* <p>
    * 采购订单头 服务实现类
    * </p>
*
* @author system
* @since 2025-04-24
*/
@Service
    public class OrdHeadServiceImpl extends ServiceImpl<OrdHeadMapper, OrdHead> implements OrdHeadService {


    ResultJSON resultJSON;

    @Autowired
    OrdHeadMapper ordHeadMapper;

    @Override
    public ResultJSON query(int page,int rows,String params){
    JSONObject jsonObject=JSON.parseObject(params);
            String contrNm = jsonObject.getString("contrNm");
                JSONArray contrDtRange = jsonObject.getJSONArray("contrDt");
                Date contrDtBegin = contrDtRange.getDate(0);
                Date contrDtEnd = contrDtRange.getDate(1);
    Page<OrdHead> ordHeadPage=new Page<>(page,rows);
    QueryWrapper<OrdHead>queryWrapper=new QueryWrapper<>();
    queryWrapper.eq("cancel_flag","0");
                queryWrapper.like(StringUtils.isNotEmpty(contrNm),"CONTR_NM",contrNm);
                 queryWrapper.between(ObjectUtils.isNotEmpty(contrDtBegin),"CONTR_DT",contrDtBegin, contrDtEnd);
    queryWrapper.orderByDesc("add_time");
    Page<OrdHead>list= ordHeadMapper.selectPage(ordHeadPage,queryWrapper);
    resultJSON=JSONTools.toResultJSON(list);
    return resultJSON;
    }

    @Override
    public ResultJSON queryByPK(String id) {
        OrdHead ordHead =  ordHeadMapper.selectByPK(id);
        resultJSON = JSONTools.toResultJSON(ordHead);
        return resultJSON;
    }


    @Override
    public ResultJSON save(String userId,String json){
    Date date = new Date();
    OrdHead ordHead =JSON.parseObject(json,new TypeReference<OrdHead>(){
    });
    if(StringUtils.isEmpty(ordHead.getId())){
    ordHead.setCancelFlag("0");
    ordHead.setAddId(userId);
    ordHead.setAddTime(date);
    ordHeadMapper.insert(ordHead);
    }else{
    ordHead.setModifyId(userId);
    ordHead.setModifyTime(date);
    ordHeadMapper.updateById(ordHead);
    }

    resultJSON=JSONTools.toResultJSON(ordHead);
    return resultJSON;
    }

    @Override
    public ResultJSON remove(String userId,String id){
    Date date=new Date();
    OrdHead ordHead = ordHeadMapper.selectById(id);
    ordHead.setCancelFlag("1");
    ordHead.setCancelId(userId);
    ordHead.setCancelTime(date);
    ordHeadMapper.updateById(ordHead);
    resultJSON=JSONTools.toResultJSON("");
    return resultJSON;
    }

        @Override
        public ResultJSON removeBatch(String userId, String ids) {
            Date date = new Date();
            List<String> list = JSON.parseObject(ids,new TypeReference<List<String>>() {
            });
            OrdHead ordHead;
            for(String id :list){
                ordHead = ordHeadMapper.selectById(id);
                ordHead.setCancelFlag("1");
                ordHead.setCancelId(userId);
                ordHead.setCancelTime(date);
                ordHeadMapper.updateById(ordHead);
            }
            resultJSON = JSONTools.toResultJSON("");
            return resultJSON;
        }

    }
