package com.shinsoft.oracle.study.service.impl;

import com.shinsoft.oracle.study.model.Penglin;
import com.shinsoft.oracle.study.mapper.PenglinMapper;
    import com.shinsoft.oracle.study.service.PenglinService;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import org.springframework.stereotype.Service;


import org.springframework.beans.factory.annotation.Autowired;
import java.util.Date;
import java.util.List;
import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONObject;
import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.TypeReference;
import com.shinsoft.tools.JSONTools;
import com.shinsoft.tools.model.common.ResultJSON;
import org.apache.commons.lang3.StringUtils;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import org.apache.commons.lang3.ObjectUtils;
import org.apache.commons.lang3.StringUtils;

/**
* <p>
    *  服务实现类
    * </p>
*
* @author system
* @since 2025-05-09
*/
@Service
    public class PenglinServiceImpl extends ServiceImpl<PenglinMapper, Penglin> implements PenglinService {


    ResultJSON resultJSON;

    @Autowired
    PenglinMapper penglinMapper;

    @Override
    public ResultJSON query(int page,int rows,String params){
    JSONObject jsonObject=JSON.parseObject(params);
            String name = jsonObject.getString("name");
            String height = jsonObject.getString("height");
            String age = jsonObject.getString("age");
            String position = jsonObject.getString("position");
            String team = jsonObject.getString("team");
    Page<Penglin> penglinPage=new Page<>(page,rows);
    QueryWrapper<Penglin>queryWrapper=new QueryWrapper<>();
    queryWrapper.eq("cancel_flag","0");
                queryWrapper.like(StringUtils.isNotEmpty(name),"NAME",name);
                queryWrapper.like(StringUtils.isNotEmpty(height),"HEIGHT",height);
                queryWrapper.like(StringUtils.isNotEmpty(age),"AGE",age);
                queryWrapper.like(StringUtils.isNotEmpty(position),"POSITION",position);
                queryWrapper.like(StringUtils.isNotEmpty(team),"TEAM",team);
    queryWrapper.orderByDesc("add_time");
    Page<Penglin>list= penglinMapper.selectPage(penglinPage,queryWrapper);
    resultJSON=JSONTools.toResultJSON(list);
    return resultJSON;
    }

    @Override
    public ResultJSON queryByPK(String id) {
        Penglin penglin =  penglinMapper.selectByPK(id);
        resultJSON = JSONTools.toResultJSON(penglin);
        return resultJSON;
    }


    @Override
    public ResultJSON save(String userId,String json){
    Date date = new Date();
    Penglin penglin =JSON.parseObject(json,new TypeReference<Penglin>(){
    });
    if(StringUtils.isEmpty(penglin.getId())){
    penglin.setCancelFlag("0");
    penglin.setAddId(userId);
    penglin.setAddTime(date);
    penglinMapper.insert(penglin);
    }else{
    penglin.setModifyId(userId);
    penglin.setModifyTime(date);
    penglinMapper.updateById(penglin);
    }

    resultJSON=JSONTools.toResultJSON(penglin);
    return resultJSON;
    }

    @Override
    public ResultJSON remove(String userId,String id){
    Date date=new Date();
    Penglin penglin = penglinMapper.selectById(id);
    penglin.setCancelFlag("1");
    penglin.setCancelId(userId);
    penglin.setCancelTime(date);
    penglinMapper.updateById(penglin);
    resultJSON=JSONTools.toResultJSON("");
    return resultJSON;
    }

        @Override
        public ResultJSON removeBatch(String userId, String ids) {
            Date date = new Date();
            List<String> list = JSON.parseObject(ids,new TypeReference<List<String>>() {
            });
            Penglin penglin;
            for(String id :list){
                penglin = penglinMapper.selectById(id);
                penglin.setCancelFlag("1");
                penglin.setCancelId(userId);
                penglin.setCancelTime(date);
                penglinMapper.updateById(penglin);
            }
            resultJSON = JSONTools.toResultJSON("");
            return resultJSON;
        }

    }
