package com.shinsoft.oracle.study.service.impl;

import com.shinsoft.oracle.study.model.Weixue;
import com.shinsoft.oracle.study.mapper.WeixueMapper;
    import com.shinsoft.oracle.study.service.WeixueService;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import org.springframework.stereotype.Service;


import org.springframework.beans.factory.annotation.Autowired;
import java.util.Date;
import java.util.List;
import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONObject;
import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.TypeReference;
import com.shinsoft.tools.JSONTools;
import com.shinsoft.tools.model.common.ResultJSON;
import org.apache.commons.lang3.StringUtils;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import org.apache.commons.lang3.ObjectUtils;
import org.apache.commons.lang3.StringUtils;

/**
* <p>
    *  服务实现类
    * </p>
*
* @author system
* @since 2025-05-09
*/
@Service
    public class WeixueServiceImpl extends ServiceImpl<WeixueMapper, Weixue> implements WeixueService {


    ResultJSON resultJSON;

    @Autowired
    WeixueMapper weixueMapper;

    @Override
    public ResultJSON query(int page,int rows,String params){
    JSONObject jsonObject=JSON.parseObject(params);
    Page<Weixue> weixuePage=new Page<>(page,rows);
    QueryWrapper<Weixue>queryWrapper=new QueryWrapper<>();
    queryWrapper.eq("cancel_flag","0");
    queryWrapper.orderByDesc("add_time");
    Page<Weixue>list= weixueMapper.selectPage(weixuePage,queryWrapper);
    resultJSON=JSONTools.toResultJSON(list);
    return resultJSON;
    }

    @Override
    public ResultJSON queryByPK(String id) {
        Weixue weixue =  weixueMapper.selectByPK(id);
        resultJSON = JSONTools.toResultJSON(weixue);
        return resultJSON;
    }


    @Override
    public ResultJSON save(String userId,String json){
    Date date = new Date();
    Weixue weixue =JSON.parseObject(json,new TypeReference<Weixue>(){
    });
    if(StringUtils.isEmpty(weixue.getId())){
    weixue.setCancelFlag("0");
    weixue.setAddId(userId);
    weixue.setAddTime(date);
    weixueMapper.insert(weixue);
    }else{
    weixue.setModifyId(userId);
    weixue.setModifyTime(date);
    weixueMapper.updateById(weixue);
    }

    resultJSON=JSONTools.toResultJSON(weixue);
    return resultJSON;
    }

    @Override
    public ResultJSON remove(String userId,String id){
    Date date=new Date();
    Weixue weixue = weixueMapper.selectById(id);
    weixue.setCancelFlag("1");
    weixue.setCancelId(userId);
    weixue.setCancelTime(date);
    weixueMapper.updateById(weixue);
    resultJSON=JSONTools.toResultJSON("");
    return resultJSON;
    }

        @Override
        public ResultJSON removeBatch(String userId, String ids) {
            Date date = new Date();
            List<String> list = JSON.parseObject(ids,new TypeReference<List<String>>() {
            });
            Weixue weixue;
            for(String id :list){
                weixue = weixueMapper.selectById(id);
                weixue.setCancelFlag("1");
                weixue.setCancelId(userId);
                weixue.setCancelTime(date);
                weixueMapper.updateById(weixue);
            }
            resultJSON = JSONTools.toResultJSON("");
            return resultJSON;
        }

    }
