package com.shinsoft.oracle.zhangqingyu.controller;

import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;


import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;
import org.springframework.web.bind.annotation.RequestMethod;
import javax.servlet.http.HttpServletRequest;

import com.shinsoft.tools.JSONTools;
import com.shinsoft.tools.ExceptionTools;
import com.shinsoft.tools.model.common.ResultJSON;
import com.shinsoft.tools.model.common.ResponseCodeMsg;

import com.shinsoft.oracle.zhangqingyu.service.ZhangqingyuService;

/**
 * <p>
 *  前端控制器
 * </p>
 *
 * @author system
 * @since 2025-05-09
 */
@RestController
//@RequestMapping("/zhangqingyu/zhangqingyu")
@RequestMapping("/Zhangqingyu")
public class ZhangqingyuController {



       @Autowired
       private ZhangqingyuService zhangqingyuService;

       ResultJSON resultJSON;


       @RequestMapping(value = "/query")
       public ResultJSON query(int page, int rows, String params,  HttpServletRequest request) {
           try {
               String userId = (String) request.getHeader("userId");
               resultJSON = zhangqingyuService.query(page, rows, params);
           } catch (Exception ex) {
               ex.printStackTrace();
               resultJSON = JSONTools.toResultJSON(ResponseCodeMsg.CODE_EX, ex);
           } finally {
               return resultJSON;
           }
       }

        @RequestMapping(value = "/queryByPK")
        public ResultJSON queryByPK(  String id,  HttpServletRequest request) {
            try {
                String userId = (String) request.getHeader("userId");
                resultJSON = zhangqingyuService.queryByPK(id);
            } catch (Exception ex) {
                 ex.printStackTrace();
                 resultJSON = JSONTools.toResultJSON(ResponseCodeMsg.CODE_EX, ex);
            } finally {
                return resultJSON;
            }
        }

       @RequestMapping(value = "/save", method = RequestMethod.POST)
       public ResultJSON save(String json,  HttpServletRequest request) {
           try {
               String userId = (String) request.getHeader("userId");
               resultJSON = zhangqingyuService.save(userId, json);
           } catch (Exception ex) {
               resultJSON = JSONTools.toResultJSON(ResponseCodeMsg.CODE_EX, ExceptionTools.getExceptionAllinformation(ex));
               ex.printStackTrace();
           } finally {
               return resultJSON;
           }
       }

       @RequestMapping(value = "/remove", method = RequestMethod.POST)
       public ResultJSON remove(String id,   HttpServletRequest request) {
           try {
               String userId = (String) request.getHeader("userId");
               resultJSON = zhangqingyuService.remove(userId, id);
           } catch (Exception ex) {
               ex.printStackTrace();
               resultJSON = JSONTools.toResultJSON(ResponseCodeMsg.CODE_EX, ex);
           } finally {
               return resultJSON;
           }
       }

        @RequestMapping(value = "/removeBatch", method = RequestMethod.POST)
        public ResultJSON removeBatch(String ids, HttpServletRequest request) {
            try {
                String userId = (String) request.getHeader("userId");
                resultJSON = zhangqingyuService.removeBatch(userId, ids);
            } catch (Exception ex) {
                ex.printStackTrace();
                resultJSON = JSONTools.toResultJSON(ResponseCodeMsg.CODE_EX, ex);
            } finally {
                return resultJSON;
            }
        }

 }
