package com.shinsoft.oracle.zhangqingyu.service.impl;

import com.shinsoft.oracle.zhangqingyu.model.Zhangqingyu;
import com.shinsoft.oracle.zhangqingyu.mapper.ZhangqingyuMapper;
    import com.shinsoft.oracle.zhangqingyu.service.ZhangqingyuService;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import org.springframework.stereotype.Service;


import org.springframework.beans.factory.annotation.Autowired;
import java.util.Date;
import java.util.List;
import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONObject;
import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.TypeReference;
import com.shinsoft.tools.JSONTools;
import com.shinsoft.tools.model.common.ResultJSON;
import org.apache.commons.lang3.StringUtils;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import org.apache.commons.lang3.ObjectUtils;
import org.apache.commons.lang3.StringUtils;

/**
* <p>
    *  服务实现类
    * </p>
*
* @author system
* @since 2025-05-09
*/
@Service
    public class ZhangqingyuServiceImpl extends ServiceImpl<ZhangqingyuMapper, Zhangqingyu> implements ZhangqingyuService {


    ResultJSON resultJSON;

    @Autowired
    ZhangqingyuMapper zhangqingyuMapper;

    @Override
    public ResultJSON query(int page,int rows,String params){
    JSONObject jsonObject=JSON.parseObject(params);
            String code = jsonObject.getString("code");
            String name = jsonObject.getString("name");
    Page<Zhangqingyu> zhangqingyuPage=new Page<>(page,rows);
    QueryWrapper<Zhangqingyu>queryWrapper=new QueryWrapper<>();
    queryWrapper.eq("cancel_flag","0");
                queryWrapper.like(StringUtils.isNotEmpty(code),"CODE",code);
                queryWrapper.like(StringUtils.isNotEmpty(name),"NAME",name);
    queryWrapper.orderByDesc("add_time");
    Page<Zhangqingyu>list= zhangqingyuMapper.selectPage(zhangqingyuPage,queryWrapper);
    resultJSON=JSONTools.toResultJSON(list);
    return resultJSON;
    }

    @Override
    public ResultJSON queryByPK(String id) {
        Zhangqingyu zhangqingyu =  zhangqingyuMapper.selectByPK(id);
        resultJSON = JSONTools.toResultJSON(zhangqingyu);
        return resultJSON;
    }


    @Override
    public ResultJSON save(String userId,String json){
    Date date = new Date();
    Zhangqingyu zhangqingyu =JSON.parseObject(json,new TypeReference<Zhangqingyu>(){
    });
    if(StringUtils.isEmpty(zhangqingyu.getId())){
    zhangqingyu.setCancelFlag("0");
    zhangqingyu.setAddId(userId);
    zhangqingyu.setAddTime(date);
    zhangqingyuMapper.insert(zhangqingyu);
    }else{
    zhangqingyu.setModifyId(userId);
    zhangqingyu.setModifyTime(date);
    zhangqingyuMapper.updateById(zhangqingyu);
    }

    resultJSON=JSONTools.toResultJSON(zhangqingyu);
    return resultJSON;
    }

    @Override
    public ResultJSON remove(String userId,String id){
    Date date=new Date();
    Zhangqingyu zhangqingyu = zhangqingyuMapper.selectById(id);
    zhangqingyu.setCancelFlag("1");
    zhangqingyu.setCancelId(userId);
    zhangqingyu.setCancelTime(date);
    zhangqingyuMapper.updateById(zhangqingyu);
    resultJSON=JSONTools.toResultJSON("");
    return resultJSON;
    }

        @Override
        public ResultJSON removeBatch(String userId, String ids) {
            Date date = new Date();
            List<String> list = JSON.parseObject(ids,new TypeReference<List<String>>() {
            });
            Zhangqingyu zhangqingyu;
            for(String id :list){
                zhangqingyu = zhangqingyuMapper.selectById(id);
                zhangqingyu.setCancelFlag("1");
                zhangqingyu.setCancelId(userId);
                zhangqingyu.setCancelTime(date);
                zhangqingyuMapper.updateById(zhangqingyu);
            }
            resultJSON = JSONTools.toResultJSON("");
            return resultJSON;
        }

    }
