package com.shinsoft.oracle.zhaobo.service.impl;

import com.shinsoft.oracle.zhaobo.model.Zhaobo;
import com.shinsoft.oracle.zhaobo.mapper.ZhaoboMapper;
    import com.shinsoft.oracle.zhaobo.service.ZhaoboService;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import org.springframework.stereotype.Service;


import org.springframework.beans.factory.annotation.Autowired;
import java.util.Date;
import java.util.List;
import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONObject;
import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.TypeReference;
import com.shinsoft.tools.JSONTools;
import com.shinsoft.tools.model.common.ResultJSON;
import org.apache.commons.lang3.StringUtils;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import org.apache.commons.lang3.ObjectUtils;
import org.apache.commons.lang3.StringUtils;

/**
* <p>
    *  服务实现类
    * </p>
*
* @author system
* @since 2025-05-08
*/
@Service
    public class ZhaoboServiceImpl extends ServiceImpl<ZhaoboMapper, Zhaobo> implements ZhaoboService {


    ResultJSON resultJSON;

    @Autowired
    ZhaoboMapper zhaoboMapper;

    @Override
    public ResultJSON query(int page,int rows,String params){
    JSONObject jsonObject=JSON.parseObject(params);
            String name = jsonObject.getString("name");
    Page<Zhaobo> zhaoboPage=new Page<>(page,rows);
    QueryWrapper<Zhaobo>queryWrapper=new QueryWrapper<>();
    queryWrapper.eq("cancel_flag","0");
                queryWrapper.like(StringUtils.isNotEmpty(name),"NAME",name);
    queryWrapper.orderByDesc("add_time");
    Page<Zhaobo>list= zhaoboMapper.selectPage(zhaoboPage,queryWrapper);
    resultJSON=JSONTools.toResultJSON(list);
    return resultJSON;
    }

    @Override
    public ResultJSON queryByPK(String id) {
        Zhaobo zhaobo =  zhaoboMapper.selectByPK(id);
        resultJSON = JSONTools.toResultJSON(zhaobo);
        return resultJSON;
    }


    @Override
    public ResultJSON save(String userId,String json){
    Date date = new Date();
    Zhaobo zhaobo =JSON.parseObject(json,new TypeReference<Zhaobo>(){
    });
    if(StringUtils.isEmpty(zhaobo.getId())){
    zhaobo.setCancelFlag("0");
    zhaobo.setAddId(userId);
    zhaobo.setAddTime(date);
    zhaoboMapper.insert(zhaobo);
    }else{
    zhaobo.setModifyId(userId);
    zhaobo.setModifyTime(date);
    zhaoboMapper.updateById(zhaobo);
    }

    resultJSON=JSONTools.toResultJSON(zhaobo);
    return resultJSON;
    }

    @Override
    public ResultJSON remove(String userId,String id){
    Date date=new Date();
    Zhaobo zhaobo = zhaoboMapper.selectById(id);
    zhaobo.setCancelFlag("1");
    zhaobo.setCancelId(userId);
    zhaobo.setCancelTime(date);
    zhaoboMapper.updateById(zhaobo);
    resultJSON=JSONTools.toResultJSON("");
    return resultJSON;
    }

        @Override
        public ResultJSON removeBatch(String userId, String ids) {
            Date date = new Date();
            List<String> list = JSON.parseObject(ids,new TypeReference<List<String>>() {
            });
            Zhaobo zhaobo;
            for(String id :list){
                zhaobo = zhaoboMapper.selectById(id);
                zhaobo.setCancelFlag("1");
                zhaobo.setCancelId(userId);
                zhaobo.setCancelTime(date);
                zhaoboMapper.updateById(zhaobo);
            }
            resultJSON = JSONTools.toResultJSON("");
            return resultJSON;
        }

    }
