package com.shinsoft.ware.controller;

import com.shinsoft.ware.service.AutoService;
import com.shinsoft.ware.service.DataPermissionService;
import com.shinsoft.tools.JSONTools;
import com.shinsoft.tools.model.common.ResponseCodeMsg;
import com.shinsoft.tools.model.common.ResultJSON;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import javax.servlet.http.HttpServletRequest;

@RestController
@RequestMapping("/DataPermission")
public class DataPermissionController {


    @Autowired
    private DataPermissionService dataPermissionService;

    ResultJSON resultJSON;


    @RequestMapping(value = "/query")
    public ResultJSON query(int page, int rows, String params,  HttpServletRequest request) {
        try {
            String userId = (String) request.getHeader("userId");
            String menuId = (String) request.getHeader("menuId");
            resultJSON = dataPermissionService.query(page, rows, userId,menuId,params);
        } catch (Exception ex) {
            ex.printStackTrace();
            resultJSON = JSONTools.toResultJSON(ResponseCodeMsg.CODE_EX, ex);
        } finally {
            return resultJSON;
        }
    }


}
