package com.shinsoft.ware.mapper;

import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.shinsoft.ware.model.SearchSingle;
import com.baomidou.mybatisplus.core.mapper.BaseMapper;
import org.apache.ibatis.annotations.Param;
import org.apache.ibatis.annotations.Select;

import java.util.Date;
import java.util.List;
import java.util.Map;

/**
 * <p>
 * Mapper 接口
 * </p>
 *
 * @author system
 * @since 2024-08-30
 */
public interface SearchSingleMapper extends BaseMapper<SearchSingle> {

    @Select("SELECT * FROM EXP_SEARCH_SINGLE WHERE ID = #{id}")
    SearchSingle selectByPK(String id);

    @Select("SELECT * FROM EXP_SEARCH_SINGLE WHERE cancel_flag = '0' and name like '%'|| #{name}||'%'")
    List<SearchSingle> selectByAnnotate(Map<String, Object> map);

    @Select("SELECT * FROM EXP_SEARCH_SINGLE WHERE cancel_flag = '0' and name like '%'|| #{params.name}||'%'")
    Page<SearchSingle> selectByAnnotatePage(Page<SearchSingle> autoPage, @Param("params") Map<String, Object> map);

    List<SearchSingle> selectByXml(Map<String, Object> map);

    Page<SearchSingle> selectByXmlPage(Page<SearchSingle> autoPage, Date birthDate, String name,
                                       @Param("code")String code, @Param("type") String type,
                                       @Param("addTimeBegin") Date addTimeBegin, @Param("addTimeEnd") Date addTimeEnd);
}
