package com.shinsoft.ware.model;

import com.alibaba.fastjson.JSONObject;
import com.alibaba.fastjson.TypeReference;
import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableName;
import com.shinsoft.generator.model.BaseModel;
import java.util.Date;
import java.util.Map;

import com.shinsoft.workflowapi.model.WorkModel;
import io.swagger.annotations.ApiModel;
import lombok.Getter;
import lombok.NoArgsConstructor;
import lombok.Setter;
import lombok.ToString;
import lombok.experimental.Accessors;
import com.alibaba.fastjson.annotation.JSONField;

/**
 * <p>
 * 
 * </p>
 *
 * @author system
 * @since 2024-08-29
 */
@Getter
@Setter
@NoArgsConstructor
@Accessors(chain = true)
@ToString
@TableName("EXP_AUTO")
@ApiModel(value = "Auto对象", description = "")
public class Auto extends BaseModel{

    private static final long serialVersionUID = 1L;

    @JSONField(format="yyyy-MM-dd")
    private Date birthDate;

    private String sex;

    private String type;

    private Integer age;

    private String code;

    private String name;

    /**
     * 工作流实例ID
     */
    private String workId;

    /**
     * 工作流路径ID
     */
    private String trackId;

    /**
     * 流程模型相关信息
     */
    @TableField(exist = false)
    private WorkModel workModel;

}
