package com.shinsoft.ware.model;

import com.alibaba.excel.annotation.ExcelIgnoreUnannotated;
import com.alibaba.excel.annotation.ExcelProperty;
import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import com.shinsoft.generator.model.BaseModel;
import java.io.Serializable;
import java.util.Date;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.EqualsAndHashCode;
import lombok.Getter;
import lombok.Setter;
import lombok.experimental.Accessors;
import com.alibaba.fastjson.annotation.JSONField;

/**
 * <p>
 * 采购订单行
 * </p>
 *
 * @author system
 * @since 2024-10-08
 */
@Getter
@Setter
@Accessors(chain = true)
@TableName("EXP_IMEXPORT")
@ApiModel(value = "Imexport对象", description = "采购订单行")
public class Imexport extends BaseModel {

    private static final long serialVersionUID = 1L;

    @ApiModelProperty("公司代码")
    private String compCd;

    @ApiModelProperty("订单头ID")
    private String ordHeadId;

    @ExcelProperty("订单号")
    private String ordNo;

    @ApiModelProperty("订单行号")
    private String ordLn;

    @ApiModelProperty("物料ID")
    private String itemId;

    @ExcelProperty("物料编码")
    private String itemCd;

    @ApiModelProperty("物料名称")
    private String itemNm;

    @ApiModelProperty("钢种")
    private String stlGrd;

    @ApiModelProperty("规格型号")
    private String specType;

    @ApiModelProperty("湿基")
    private Double quantityWet;

    @ApiModelProperty("数量")
    private Double quantity;

    @ApiModelProperty("计量单位")
    private String unit;

    @ApiModelProperty("合同价")
    private Double contrPrice;

    @ApiModelProperty("单价")
    private Double price;

    @ApiModelProperty("含税单价")
    private Double taxPrice;

    @ApiModelProperty("税率")
    private Double taxRate;

    @ApiModelProperty("税码")
    private String taxRateCd;

    @ApiModelProperty("合同汇率")
    private Double contrExRate;

    @ApiModelProperty("结算汇率")
    private Double payExRate;

    @ApiModelProperty("锁汇汇率")
    private Double lockExRate;

    @ApiModelProperty("汇率日期")
    private Date exRateDt;

    @ApiModelProperty("金额")
    private Double amount;

    @ApiModelProperty("税额")
    private Double taxAmount;

    @ApiModelProperty("价税合计")
    private Double totalAmount;

    @ApiModelProperty("币种")
    private String currencyCd;

    @JSONField(format="yyyy-MM-dd")
    @ApiModelProperty("交货日期")
    private Date delvDt;

    @ApiModelProperty("上传人")
    private String submitEmpId;

    @ApiModelProperty("上传标记")
    private String submitFlag;

    @ApiModelProperty("上传时间")
    private Date submitDtm;

    @ApiModelProperty("原订单号")
    private String ordNoOld;

    @ApiModelProperty("原订单行号")
    private String ordLnOld;

    @ApiModelProperty("允差上限")
    private Double delvTolMax;

    @ApiModelProperty("允差下限")
    private Double delvTolMin;

    @ApiModelProperty("确认人")
    private String checkEmpId;

    @ApiModelProperty("确认标记")
    private String checkYn;

    @ApiModelProperty("确认时间")
    private Date checkDtm;

    @ApiModelProperty("订单状态")
    private String ordStatus;

    @ApiModelProperty("采购部门ID")
    private String deptId;

    @ApiModelProperty("采购部门编码")
    private String deptCd;

    @ApiModelProperty("采购部门")
    private String deptNm;

    @ApiModelProperty("采购人员身份证")
    private String purEmpCard;

    @ApiModelProperty("采购人员")
    private String purEmpNm;

    @ApiModelProperty("库存组织代码")
    private String invOrgCd;

    @ApiModelProperty("库存组织名称")
    private String invOrgNm;

    @ApiModelProperty("销售订单号")
    private String saleNo;

    @ApiModelProperty("销售订单行号")
    private String saleLineNo;

    @ApiModelProperty("生产指令号")
    private String directiveNo;

    @ApiModelProperty("结算量")
    private String account;

    @ApiModelProperty("入库量")
    private Double stoQuantity;

    @ApiModelProperty("入库状态")
    private String stoFlag;

    @ApiModelProperty("备用1(合同行号ID)")
    private String reserve1;

    @ApiModelProperty("备用2")
    private String reserve2;

    @ApiModelProperty("ERP接口ID")
    private Double toErpId;

    @ApiModelProperty("供应商编码(日照)")
    private String actSupplierCd;

    @ApiModelProperty("供应商名称(日照)")
    private String actSupplierNm;

    @ApiModelProperty("钢板厚度")
    private String reserve3;

    @ApiModelProperty("备用4")
    private String reserve4;

    @ApiModelProperty("备用5")
    private String reserve5;

    @ApiModelProperty("备用6")
    private String reserve6;

    @ApiModelProperty("备用7")
    private String reserve7;

    @ApiModelProperty("备用8")
    private String reserve8;

    @ApiModelProperty("传送MES时间")
    private String reserve9;

    @ApiModelProperty("传送MES标记")
    private String reserve10;

    @ApiModelProperty("备用")
    private String reserve11;

    @ApiModelProperty("备用")
    private String reserve12;

    @ApiModelProperty("备用")
    private String reserve13;

    @ApiModelProperty("备用")
    private String reserve14;

    @ApiModelProperty("备用")
    private String reserve15;

    @ApiModelProperty("备用")
    private String reserve16;

    @ApiModelProperty("备用")
    private String reserve17;

    @ApiModelProperty("备用")
    private String reserve18;

    @ApiModelProperty("备用")
    private String reserve19;

    @ApiModelProperty("备用")
    private String reserve20;

    @ApiModelProperty("上允差")
    private String quantityUpper;

    @ApiModelProperty("下允差")
    private String quantityLower;

    @ApiModelProperty("费用类型")
    private String expenseType;

    @ApiModelProperty("集团贸易生成标记")
    private String tradeFlag;

    @ApiModelProperty("集团贸易生成时间")
    @JSONField(format="yyyy-MM-dd HH:mm:ss")
    private Date tradeTime;
}
