package com.shinsoft.ware.service.impl;

import com.shinsoft.ware.service.FeginService;
import com.shinsoft.frameworkapi.model.SysDepartment;
import com.shinsoft.frameworkapi.model.SysUser;
import com.shinsoft.frameworkapi.model.TreeNode;
import com.shinsoft.frameworkapi.service.FrameworkService;
import com.shinsoft.tools.JSONTools;
import com.shinsoft.tools.model.common.ResultJSON;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.List;

@Service
public class FeginServiceImpl implements FeginService {

    ResultJSON resultJSON;

    @Autowired
    FrameworkService frameworkService;

    @Override
    public ResultJSON query( String userId) {

        //查对象
        resultJSON = frameworkService.queryUserById(userId);
        if (resultJSON.getCode() != 0) {
            return resultJSON;
        }
        SysUser sysUser = JSONTools.objectToModel(resultJSON.getData(), SysUser.class);


        //查列表
        resultJSON = frameworkService.queryDeptListByUserId(userId);
        if (resultJSON.getCode() != 0) {
            return resultJSON;
        }
        List<SysDepartment> departmentList = JSONTools.objectToList(resultJSON.getData(), SysDepartment.class);


        //查列表
        resultJSON = frameworkService.queryDeptTreeByUserId(userId);
        if (resultJSON.getCode() != 0) {
            return resultJSON;
        }
        List<SysDepartment> departmentTree = JSONTools.objectToList(resultJSON.getData(), SysDepartment.class);




        resultJSON = JSONTools.toResultJSON("");
        return resultJSON;
    }
}
