-- drop table     ;
create table EXP_QUERY
(
        BIRTH_DATE      DATE,
        SEX      VARCHAR2(1)  ,
        TYPE      VARCHAR2(50)  ,
        AGE      NUMBER(9,0),
        CODE      VARCHAR2(50)  ,
        NAME      VARCHAR2(50)  ,
        ID      VARCHAR2(32) not null ,
        PROCESS_INSTANCE_ID      VARCHAR2(32)  ,
        PROCESS_INSTANCE_STATUS      VARCHAR2(50)  ,
        ADD_ID      VARCHAR2(32)  ,
        ADD_CODE      VARCHAR2(50)  ,
        ADD_NAME      VARCHAR2(50)  ,
        ADD_DEPT_Id      VARCHAR2(50)  ,
        ADD_DEPT_CODE      VARCHAR2(50)  ,
        ADD_DEPT_NAME      VARCHAR2(50)  ,
        ADD_TIME      DATE,
        MODIFY_ID      VARCHAR2(32)  ,
        MODIFY_CODE      VARCHAR2(50)  ,
        MODIFY_NAME      VARCHAR2(50)  ,
        MODIFY_TIME      DATE,
        CANCEL_ID      VARCHAR2(32)  ,
        CANCEL_CODE      VARCHAR2(50)  ,
        CANCEL_NAME      VARCHAR2(50)  ,
        CANCEL_TIME      DATE,
        CANCEL_FLAG      VARCHAR2(50)  ,
        BELONG_ID      VARCHAR2(32)  
)
tablespace SGIIP_DATA
pctfree 10
initrans 1
maxtrans 255
storage
(
initial 64
next 1
minextents 1
maxextents unlimited
);
-- Add comments to the columns

    comment on column EXP_QUERY.BIRTH_DATE
    is '出生日期';
    comment on column EXP_QUERY.SEX
    is '性别';
    comment on column EXP_QUERY.TYPE
    is '类型';
    comment on column EXP_QUERY.AGE
    is '年龄';
    comment on column EXP_QUERY.CODE
    is '编码';
    comment on column EXP_QUERY.NAME
    is '名称';
    comment on column EXP_QUERY.ID
    is '主键';
    comment on column EXP_QUERY.PROCESS_INSTANCE_ID
    is '流程id';
    comment on column EXP_QUERY.PROCESS_INSTANCE_STATUS
    is '流程状态';
    comment on column EXP_QUERY.ADD_ID
    is '添加人id';
    comment on column EXP_QUERY.ADD_CODE
    is '添加人编码';
    comment on column EXP_QUERY.ADD_NAME
    is '添加人名称';
    comment on column EXP_QUERY.ADD_DEPT_Id
    is '添加部门id';
    comment on column EXP_QUERY.ADD_DEPT_CODE
    is '添加部门编码';
    comment on column EXP_QUERY.ADD_DEPT_NAME
    is '添加部门名称';
    comment on column EXP_QUERY.ADD_TIME
    is '添加时间';
    comment on column EXP_QUERY.MODIFY_ID
    is '修改人id';
    comment on column EXP_QUERY.MODIFY_CODE
    is '修改人编码';
    comment on column EXP_QUERY.MODIFY_NAME
    is '修改人名称';
    comment on column EXP_QUERY.MODIFY_TIME
    is '修改时间';
    comment on column EXP_QUERY.CANCEL_ID
    is '作废人id';
    comment on column EXP_QUERY.CANCEL_CODE
    is '作废人编码';
    comment on column EXP_QUERY.CANCEL_NAME
    is '作废人名称';
    comment on column EXP_QUERY.CANCEL_TIME
    is '作废时间';
    comment on column EXP_QUERY.CANCEL_FLAG
    is '作废标记';
    comment on column EXP_QUERY.BELONG_ID
    is 'BELONG_ID';

-- Create/Recreate primary, unique and foreign key constraints
alter table EXP_QUERY
add constraint EXP_QUERY_PK primary key (ID)
using index
tablespace SGIIP_DATA
pctfree 10
initrans 2
maxtrans 255
storage
(
initial 64K
next 1M
minextents 1
maxextents unlimited
);
